﻿#include "DataBase_String.mqh"

class EVENT_MESSAGE
{
private:
  static ushort EventID;
  static DATABASE_STRING Messages;

  static int StringSplit( const string &Str, string &StrArray[], const int MaxLength = 63 )
  {
    const int Size = ::ArrayResize(StrArray, ::StringLen(Str) / MaxLength + (bool)(::StringLen(Str) % MaxLength));

    for (int i = 0; i < Size; i++)
      StrArray[i] = ::StringSubstr(Str, i * MaxLength, MaxLength);

    return(Size);
  }

public:
  static void SetEventID( const ushort iEventID )
  {
    EVENT_MESSAGE::EventID = iEventID;
    return;
  }
  
  static bool Send( const string Str, const long chartID )
  {
    bool Res = true;

    string StrArray[];
    const int Size = EVENT_MESSAGE::StringSplit(Str, StrArray);

    const int ID = ::MathRand() + (int)::ChartID();
    const int Length = ::StringLen(Str);

    for (int i = 0; i < Size; i++)
      Res &= ::EventChartCustom(chartID, EVENT_MESSAGE::EventID, ID, (i == Size - 1) ? Length + 1 : 0, StrArray[i]);

    return(Res);
  }

  static bool OnChartEvent( const int id, const long &lparam, const double &dparam, const string& sparam )
  {
    bool Res = false;

    if (id == CHARTEVENT_CUSTOM + EVENT_MESSAGE::EventID)
    {
      const int Length = EVENT_MESSAGE::Messages.Add((int)lparam, sparam);

      Res = dparam;
      
      if (Res && ((int)dparam) != Length + 1)
        ::Alert("Loss on message delivery!");
    }

    return(Res);
  }

  static string Receive( const long &lparam )
  {
    const string Str = EVENT_MESSAGE::Messages.Get((int)lparam);

    EVENT_MESSAGE::Messages.Delete((int)lparam);

    return(Str);
  }
};

static ushort EVENT_MESSAGE::EventID = 0;
static DATABASE_STRING EVENT_MESSAGE::Messages;